/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.isobus.type;

import nl.cloudfarming.client.isobus.model.Position;
import nl.cloudfarming.client.isobus.model.PositionStatusEnum;

/**
 * Utility methods for generated Position class.
 * 
 * @author johan
 */
public class Positions {
    
    public static boolean isUsable(Position position) {
        PositionStatusEnum status = position.getPositionStatus();

        if (status == null || status == PositionStatusEnum.ERROR || status == PositionStatusEnum.NO_GPS_FIX) {
            return false;
        }

        // sometimes the first timelog record contains a valid status but has a location at the origin, GPS still initializing?
        double lon = position.getPositionEast().doubleValue();
        double lat = position.getPositionNorth().doubleValue();

        return !(lat == 0.0 && lon == 0.0);
    }
}
